function [err,vals] = harm0 (A,m,v,lam)
%----------------------------------------
% [err,vals] = harm0 (A,m,v,lam) 
% performs m steps of the corrected arnoldi
% process. - SELECTS eigenvalues
% closest to lam 
%----------------------------------------
   n = size(A,1);
%% define sigma for Harmonic values
   sigma = 0.0; 
%----------------------------------------
% start procedure
%----------------------------------------
  ro = norm(v,2)  ; 
  t = 1.0/ ro   ;
  V(1:n,1) = v*t; 
%% 
  for i=1:m 
     i1 = i + 1  ;	
     V(1:n,i1) = A*V(1:n,i)  ;
%----------------------------------------
%                modified GS  ;
%----------------------------------------
    for j=1:i
        t = V(1:n,j)'*V(1:n,i1)  ;
        H(j,i) = t  ;
	V(1:n,i1) = V(1:n,i1) - t*V(1:n,j)  ;
    end  ;
    t = norm(V(1:n,i1),2)  ;
    H(i1,i) = t  ;
    if (t  ~= 0.0)  
       t = 1.0 / t  ;
       V(1:n,i1) = V(1:n,i1)*t  ; 
    end  
%----------------------------------------
% Arnoldi Objects + projection matrices.. 
%----------------------------------------
    Hm = H(1:i,1:i);
    S = (Hm' - sigma*eye(i)); 
    G = S*S';
    G(i,i) = G(i,i) + H(i+1,i)^2;
%----------------------------------------
    vals= eig(G,S) ; 
    err(i) = min(abs(lam - vals));
  end

