 function [L,U] = sjki(A) 
%---------------------------------------------
%  function [L,U] = sjki(A) 
%  performs sparse LU factorization of a matrix A 
%  uses the jki version of Gaussian ELimination
%---------------------------------------------
 n = size(A,1) ;
 L = sparse(0,0);  U = sparse(0,0); 
 for j=1:n 
   w = A(:,j);
   while (1) 
     [ii, jj, r] = find(w) ;
     [top, k]  = min(ii);
     if (top >= j) 
       break
     end
     t = r(k);
     U(top,j) = t;
%% sparse saxpy - can be done with sparse
%% accumulator.
     w = w - t*L(:,top);
     w(top) = 0.0;
  end;
  if (w(j) == 0.0) 
     w(j) = eps;
  end
  U(j,j) = w(j) ;
  L(:,j) = w/w(j) ; 
 end 
