%% ---------- define a finite difference matrix 
%% ---------- with a zero convection term (A=A')
A = fd3d(25, 25, 1, 0.0, 0.0, 0., 0);
%% ---------- dimension of A 
n = size(A,1);
maxsteps = 200;
%% ---------- right-hand side
b = A*ones(n,1);
%%---------- call MR 
[x, r2] = mr(A, b, zeros(n,1), maxsteps) ;
%%---------- define preconditioner
  D = 1 ./ diag(A);
  L = tril(A)*diag(D);
  U = triu(A);
  L = sparse(L); U = sparse(U);
%%---------- Gauss_seidel
 [x, r2] = gs(A, b, maxsteps, 0.0, zeros(n,1));
%%----------SOR-precond. MR
 [x, r3] = Pmr(A, L, U, b, zeros(n,1), maxsteps) ;
%%
%%---------- plot 3 residual curves..  
semilogy([1:length(r1)],r1,'k-',[1:length(r2)],r2,'b--', ...
[1:length(r3)],r3,'r-.');
h1=legend('Min-Res','Gauss-Seidel','Prec. Min-Res') ;
set(h1,'fontsize',18,'location','southwest') 

