 function [G] = utu (A) 
%---------------------------------------------
%  function [L,U] = utu (A) 
%  performs Cholesky factorization of A 
%  yields an upper triangular matrix.
%---------------------------------------------
 n = size(A,1) ;
 for k=1:n
     for i=k+1:n
        piv = A(k,i)/A(k,k);
        A(i,i:n)=A(i,i:n)-piv*A(k,i:n);
     end 
     G(k,k:n) = A(k,k:n)/sqrt(A(k,k));
 end
